package kr.co.vividnext.sodalive.admin.content.series

import org.springframework.data.domain.Pageable
import org.springframework.stereotype.Service

@Service
class AdminContentSeriesService(private val repository: AdminContentSeriesRepository) {
    fun getSeriesList(pageable: Pageable): GetAdminSeriesListResponse {
        val totalCount = repository.getSeriesTotalCount()
        val items = repository.getSeriesList(
            offset = pageable.offset,
            limit = pageable.pageSize.toLong()
        )

        return GetAdminSeriesListResponse(totalCount, items)
    }

    fun searchSeriesList(searchWord: String): List<GetAdminSearchSeriesListItem> {
        return repository.searchSeriesList(searchWord)
    }
}
