package kr.co.vividnext.sodalive.admin.marketing

import kr.co.vividnext.sodalive.common.ApiResponse
import org.springframework.data.domain.Pageable
import org.springframework.security.access.prepost.PreAuthorize
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.PutMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

@RestController
@PreAuthorize("hasRole('ADMIN')")
@RequestMapping("/admin/marketing/media-partner")
class AdminAdMediaPartnerController(private val service: AdminAdMediaPartnerService) {
    @PostMapping
    fun createMediaPartner(
        @RequestBody request: CreateAdMediaPartnerRequest
    ) = ApiResponse.ok(service.createMediaPartner(request))

    @PutMapping
    fun updateMediaPartner(
        @RequestBody request: UpdateAdMediaPartnerRequest
    ) = ApiResponse.ok(service.updateMediaPartner(request))

    @GetMapping
    fun getMediaPartnerList(pageable: Pageable) = ApiResponse.ok(
        service.getMediaPartnerList(
            offset = pageable.offset,
            limit = pageable.pageSize.toLong()
        )
    )
}
