package kr.co.vividnext.sodalive.can.charge.temp

import kr.co.vividnext.sodalive.can.charge.VerifyRequest
import kr.co.vividnext.sodalive.common.ApiResponse
import kr.co.vividnext.sodalive.common.SodaException
import kr.co.vividnext.sodalive.member.Member
import org.springframework.security.core.annotation.AuthenticationPrincipal
import org.springframework.security.core.userdetails.User
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

@RestController
@RequestMapping("/charge/temp")
class ChargeTempController(private val service: ChargeTempService) {
    @PostMapping
    fun charge(
        @RequestBody request: ChargeTempRequest,
        @AuthenticationPrincipal(expression = "#this == 'anonymousUser' ? null : member") member: Member?
    ) = run {
        if (member == null) {
            throw SodaException("로그인 정보를 확인해주세요.")
        }

        ApiResponse.ok(service.charge(member, request))
    }

    @PostMapping("/verify")
    fun verify(
        @RequestBody request: VerifyRequest,
        @AuthenticationPrincipal user: User
    ) = ApiResponse.ok(service.verify(user, request))
}
