package kr.co.vividnext.sodalive.content.main.banner

import kr.co.vividnext.sodalive.common.BaseEntity
import kr.co.vividnext.sodalive.content.main.tab.AudioContentMainTab
import kr.co.vividnext.sodalive.creator.admin.content.series.Series
import kr.co.vividnext.sodalive.event.Event
import kr.co.vividnext.sodalive.member.Member
import javax.persistence.Column
import javax.persistence.Entity
import javax.persistence.EnumType
import javax.persistence.Enumerated
import javax.persistence.FetchType
import javax.persistence.JoinColumn
import javax.persistence.OneToOne
import javax.persistence.Table

@Entity
@Table(name = "content_banner")
data class AudioContentBanner(
    @Column(nullable = false)
    var thumbnailImage: String = "",
    @Enumerated(value = EnumType.STRING)
    var type: AudioContentBannerType,
    @Column(nullable = false)
    var isAdult: Boolean = false,
    @Column(nullable = false)
    var isActive: Boolean = true,
    @Column(nullable = false)
    var orders: Int = 1
) : BaseEntity() {
    @OneToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "event_id", nullable = true)
    var event: Event? = null

    @OneToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "creator_id", nullable = true)
    var creator: Member? = null

    @OneToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "series_id", nullable = true)
    var series: Series? = null

    @OneToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "tab_id", nullable = true)
    var tab: AudioContentMainTab? = null

    @Column(nullable = true)
    var link: String? = null
}

enum class AudioContentBannerType {
    EVENT, CREATOR, LINK, SERIES
}
