package kr.co.vividnext.sodalive.faq

import kr.co.vividnext.sodalive.common.BaseEntity
import javax.persistence.Column
import javax.persistence.Entity
import javax.persistence.FetchType
import javax.persistence.JoinColumn
import javax.persistence.ManyToOne

@Entity
data class Faq(
    @Column(nullable = false)
    var question: String,
    @Column(columnDefinition = "TEXT", nullable = false)
    var answer: String,
    var isActive: Boolean = true,
    val orders: Int = 1
) : BaseEntity() {
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "category_id", nullable = false)
    var category: FaqCategory? = null
}
